Index: sys/kern/uipc_syscalls.c
===================================================================
--- sys/kern/uipc_syscalls.c	(revision 312784)
+++ sys/kern/uipc_syscalls.c	(working copy)
@@ -94,7 +94,7 @@ static int sockargs(struct mbuf **, char *, sockle
  */
 int
 getsock_cap(struct thread *td, int fd, cap_rights_t *rightsp,
-    struct file **fpp, u_int *fflagp, struct filecaps *havecapsp)
+    struct file **fpp, u_int *fflagp, struct filecaps *havecapsp, short type)
 {
 	struct file *fp;
 	int error;
@@ -102,7 +102,7 @@ getsock_cap(struct thread *td, int fd, cap_rights_
 	error = fget_cap(td, fd, rightsp, &fp, havecapsp);
 	if (error != 0)
 		return (error);
-	if (fp->f_type != DTYPE_SOCKET) {
+	if (fp->f_type != type && type != 0) {
 		fdrop(fp, td);
 		if (havecapsp != NULL)
 			filecaps_free(havecapsp);
@@ -191,7 +191,7 @@ kern_bindat(struct thread *td, int dirfd, int fd,
 	AUDIT_ARG_FD(fd);
 	AUDIT_ARG_SOCKADDR(td, dirfd, sa);
 	error = getsock_cap(td, fd, cap_rights_init(&rights, CAP_BIND),
-	    &fp, NULL, NULL);
+	    &fp, NULL, NULL, DTYPE_SOCKET);
 	if (error != 0)
 		return (error);
 	so = fp->f_data;
@@ -232,6 +232,7 @@ int
 sys_listen(struct thread *td, struct listen_args *uap)
 {
 	struct socket *so;
+	struct solisten *sol;
 	struct file *fp;
 	cap_rights_t rights;
 	int error;
@@ -238,17 +239,33 @@ sys_listen(struct thread *td, struct listen_args *
 
 	AUDIT_ARG_FD(uap->s);
 	error = getsock_cap(td, uap->s, cap_rights_init(&rights, CAP_LISTEN),
-	    &fp, NULL, NULL);
-	if (error == 0) {
+	    &fp, NULL, NULL, 0);
+	if (error)
+		return (error);
+
+	switch (fp->f_type) {
+	case DTYPE_SOCKET:
 		so = fp->f_data;
 #ifdef MAC
 		error = mac_socket_check_listen(td->td_ucred, so);
 		if (error == 0)
 #endif
-			error = solisten(so, uap->backlog, td);
-		fdrop(fp, td);
+			error = solisten(so, uap->backlog, td, fp);
+		break;
+	case DTYPE_SOLISTEN:
+		sol = fp->f_data;
+#ifdef MAC
+		QQQ
+		if (error == 0)
+#endif
+			error = sollisten(sol, uap->backlog, td, fp);	
+		break;
+	default:
+		error = ENOTSOCK;
 	}
-	return(error);
+	fdrop(fp, td);
+
+	return (error);
 }
 
 /*
@@ -308,9 +325,10 @@ int
 kern_accept4(struct thread *td, int s, struct sockaddr **name,
     socklen_t *namelen, int flags, struct file **fp)
 {
-	struct file *headfp, *nfp = NULL;
+	struct file *solfp, *nfp = NULL;
 	struct sockaddr *sa = NULL;
-	struct socket *head, *so;
+	struct solisten *sol;
+	struct socket *so;
 	struct filecaps fcaps;
 	cap_rights_t rights;
 	u_int fflag;
@@ -322,16 +340,17 @@ kern_accept4(struct thread *td, int s, struct sock
 
 	AUDIT_ARG_FD(s);
 	error = getsock_cap(td, s, cap_rights_init(&rights, CAP_ACCEPT),
-	    &headfp, &fflag, &fcaps);
+	    &solfp, &fflag, &fcaps, 0);
 	if (error != 0)
 		return (error);
-	head = headfp->f_data;
-	if ((head->so_options & SO_ACCEPTCONN) == 0) {
-		error = EINVAL;
+	if (solfp->f_type != DTYPE_SOLISTEN) {
+		error = solfp->f_type == DTYPE_SOCKET ? EINVAL : ENOTSOCK;
 		goto done;
 	}
+	sol = solfp->f_data;
 #ifdef MAC
-	error = mac_socket_check_accept(td->td_ucred, head);
+	QQQ
+	error = mac_socket_check_accept(td->td_ucred, sol);
 	if (error != 0)
 		goto done;
 #endif
@@ -339,31 +358,27 @@ kern_accept4(struct thread *td, int s, struct sock
 	    (flags & SOCK_CLOEXEC) ? O_CLOEXEC : 0, &fcaps);
 	if (error != 0)
 		goto done;
-	ACCEPT_LOCK();
-	if ((head->so_state & SS_NBIO) && TAILQ_EMPTY(&head->so_comp)) {
-		ACCEPT_UNLOCK();
+	SOLISTEN_LOCK(sol);
+	if ((sol->sol_state & SS_NBIO) && TAILQ_EMPTY(&sol->sol_comp)) {
+		SOLISTEN_UNLOCK(sol);
 		error = EWOULDBLOCK;
 		goto noconnection;
 	}
-	while (TAILQ_EMPTY(&head->so_comp) && head->so_error == 0) {
-		if (head->so_rcv.sb_state & SBS_CANTRCVMORE) {
-			head->so_error = ECONNABORTED;
-			break;
-		}
-		error = msleep(&head->so_timeo, &accept_mtx, PSOCK | PCATCH,
+	while (TAILQ_EMPTY(&sol->sol_comp) && sol->sol_error == 0) {
+		error = msleep(&sol->sol_comp, &sol->sol_mutex, PSOCK | PCATCH,
 		    "accept", 0);
 		if (error != 0) {
-			ACCEPT_UNLOCK();
+			SOLISTEN_UNLOCK(sol);
 			goto noconnection;
 		}
 	}
-	if (head->so_error) {
-		error = head->so_error;
-		head->so_error = 0;
-		ACCEPT_UNLOCK();
+	if (sol->sol_error) {
+		error = sol->sol_error;
+		sol->sol_error = 0;
+		SOLISTEN_UNLOCK(sol);
 		goto noconnection;
 	}
-	so = TAILQ_FIRST(&head->so_comp);
+	so = TAILQ_FIRST(&sol->sol_comp);
 	KASSERT(!(so->so_qstate & SQ_INCOMP), ("accept1: so SQ_INCOMP"));
 	KASSERT(so->so_qstate & SQ_COMP, ("accept1: so not SQ_COMP"));
 
@@ -375,26 +390,26 @@ kern_accept4(struct thread *td, int s, struct sock
 	SOCK_LOCK(so);			/* soref() and so_state update */
 	soref(so);			/* file descriptor reference */
 
-	TAILQ_REMOVE(&head->so_comp, so, so_list);
-	head->so_qlen--;
+	TAILQ_REMOVE(&sol->sol_comp, so, so_list);
+	sol->sol_qlen--;
 	if (flags & ACCEPT4_INHERIT)
-		so->so_state |= (head->so_state & SS_NBIO);
+		so->so_state |= (sol->sol_state & SS_NBIO);
 	else
 		so->so_state |= (flags & SOCK_NONBLOCK) ? SS_NBIO : 0;
 	so->so_qstate &= ~SQ_COMP;
-	so->so_head = NULL;
+	so->so_listen = NULL;
 
 	SOCK_UNLOCK(so);
-	ACCEPT_UNLOCK();
+	SOLISTEN_UNLOCK(sol);
 
 	/* An extra reference on `nfp' has been held for us by falloc(). */
 	td->td_retval[0] = fd;
 
-	/* connection has been removed from the listen queue */
-	KNOTE_UNLOCKED(&head->so_rcv.sb_sel.si_note, 0);
+	/* Connection has been removed from the listen queue. */
+	KNOTE_UNLOCKED(&sol->sol_selinfo.si_note, 0);
 
 	if (flags & ACCEPT4_INHERIT) {
-		pgid = fgetown(&head->so_sigio);
+		pgid = fgetown(&sol->sol_sigio);
 		if (pgid != 0)
 			fsetown(pgid, &so->so_sigio);
 	} else {
@@ -456,7 +471,7 @@ done:
 	}
 	if (nfp != NULL)
 		fdrop(nfp, td);
-	fdrop(headfp, td);
+	fdrop(solfp, td);
 	return (error);
 }
 
@@ -518,7 +533,7 @@ kern_connectat(struct thread *td, int dirfd, int f
 	AUDIT_ARG_FD(fd);
 	AUDIT_ARG_SOCKADDR(td, dirfd, sa);
 	error = getsock_cap(td, fd, cap_rights_init(&rights, CAP_CONNECT),
-	    &fp, NULL, NULL);
+	    &fp, NULL, NULL, DTYPE_SOCKET);
 	if (error != 0)
 		return (error);
 	so = fp->f_data;
@@ -761,7 +776,7 @@ kern_sendit(struct thread *td, int s, struct msghd
 		AUDIT_ARG_SOCKADDR(td, AT_FDCWD, mp->msg_name);
 		cap_rights_set(&rights, CAP_CONNECT);
 	}
-	error = getsock_cap(td, s, &rights, &fp, NULL, NULL);
+	error = getsock_cap(td, s, &rights, &fp, NULL, NULL, DTYPE_SOCKET);
 	if (error != 0) {
 		m_freem(control);
 		return (error);
@@ -937,7 +952,7 @@ kern_recvit(struct thread *td, int s, struct msghd
 
 	AUDIT_ARG_FD(s);
 	error = getsock_cap(td, s, cap_rights_init(&rights, CAP_RECV),
-	    &fp, NULL, NULL);
+	    &fp, NULL, NULL, DTYPE_SOCKET);
 	if (error != 0)
 		return (error);
 	so = fp->f_data;
@@ -1205,7 +1220,6 @@ sys_recvmsg(struct thread *td, struct recvmsg_args
 int
 sys_shutdown(struct thread *td, struct shutdown_args *uap)
 {
-	struct socket *so;
 	struct file *fp;
 	cap_rights_t rights;
 	int error;
@@ -1212,21 +1226,27 @@ sys_shutdown(struct thread *td, struct shutdown_ar
 
 	AUDIT_ARG_FD(uap->s);
 	error = getsock_cap(td, uap->s, cap_rights_init(&rights, CAP_SHUTDOWN),
-	    &fp, NULL, NULL);
-	if (error == 0) {
-		so = fp->f_data;
-		error = soshutdown(so, uap->how);
-		/*
-		 * Previous versions did not return ENOTCONN, but 0 in
-		 * case the socket was not connected. Some important
-		 * programs like syslogd up to r279016, 2015-02-19,
-		 * still depend on this behavior.
-		 */
-		if (error == ENOTCONN &&
-		    td->td_proc->p_osrel < P_OSREL_SHUTDOWN_ENOTCONN)
-			error = 0;
-		fdrop(fp, td);
+	    &fp, NULL, NULL, 0);
+	if (error)
+		return (error);
+	switch (fp->f_type) {
+	case DTYPE_SOCKET:
+		error = soshutdown((struct socket *)fp->f_data, uap->how);
+		break;
+	case DTYPE_SOLISTEN:
+		error = ENOTCONN;
+		break;
 	}
+	/*
+	 * Previous versions did not return ENOTCONN, but 0 in
+	 * case the socket was not connected. Some important
+	 * programs like syslogd up to r279016, 2015-02-19,
+	 * still depend on this behavior.
+	 */
+	if (error == ENOTCONN &&
+	    td->td_proc->p_osrel < P_OSREL_SHUTDOWN_ENOTCONN)
+		error = 0;
+	fdrop(fp, td);
 	return (error);
 }
 
@@ -1242,7 +1262,6 @@ int
 kern_setsockopt(struct thread *td, int s, int level, int name, void *val,
     enum uio_seg valseg, socklen_t valsize)
 {
-	struct socket *so;
 	struct file *fp;
 	struct sockopt sopt;
 	cap_rights_t rights;
@@ -1271,13 +1290,21 @@ kern_setsockopt(struct thread *td, int s, int leve
 
 	AUDIT_ARG_FD(s);
 	error = getsock_cap(td, s, cap_rights_init(&rights, CAP_SETSOCKOPT),
-	    &fp, NULL, NULL);
-	if (error == 0) {
-		so = fp->f_data;
-		error = sosetopt(so, &sopt);
-		fdrop(fp, td);
+	    &fp, NULL, NULL, 0);
+	if (error)
+		return (error);
+	switch (fp->f_type) {
+	case DTYPE_SOCKET:
+		error = sosetopt((struct socket *)fp->f_data, &sopt);
+		break;
+	case DTYPE_SOLISTEN:
+		error = solsetopt((struct solisten *)fp->f_data, &sopt);
+		break;
+	default:
+		error = ENOTSOCK;
 	}
-	return(error);
+	fdrop(fp, td);
+	return (error);
 }
 
 int
@@ -1308,7 +1335,6 @@ int
 kern_getsockopt(struct thread *td, int s, int level, int name, void *val,
     enum uio_seg valseg, socklen_t *valsize)
 {
-	struct socket *so;
 	struct file *fp;
 	struct sockopt sopt;
 	cap_rights_t rights;
@@ -1337,13 +1363,23 @@ kern_getsockopt(struct thread *td, int s, int leve
 
 	AUDIT_ARG_FD(s);
 	error = getsock_cap(td, s, cap_rights_init(&rights, CAP_GETSOCKOPT),
-	    &fp, NULL, NULL);
-	if (error == 0) {
-		so = fp->f_data;
-		error = sogetopt(so, &sopt);
+	    &fp, NULL, NULL, 0);
+	if (error)
+		return (error);
+	switch (fp->f_type) {
+	case DTYPE_SOCKET:
+		error = sogetopt((struct socket *)fp->f_data, &sopt);
 		*valsize = sopt.sopt_valsize;
-		fdrop(fp, td);
+		break;
+	case DTYPE_SOLISTEN:
+		error = solgetopt((struct solisten *)fp->f_data, &sopt);
+		*valsize = sopt.sopt_valsize;
+		break;
+		break;
+	default:
+		error = ENOTSOCK;
 	}
+	fdrop(fp, td);
 	return (error);
 }
 
@@ -1390,7 +1426,7 @@ kern_getsockname(struct thread *td, int fd, struct
 
 	AUDIT_ARG_FD(fd);
 	error = getsock_cap(td, fd, cap_rights_init(&rights, CAP_GETSOCKNAME),
-	    &fp, NULL, NULL);
+	    &fp, NULL, NULL, DTYPE_SOCKET);
 	if (error != 0)
 		return (error);
 	so = fp->f_data;
@@ -1477,7 +1513,7 @@ kern_getpeername(struct thread *td, int fd, struct
 
 	AUDIT_ARG_FD(fd);
 	error = getsock_cap(td, fd, cap_rights_init(&rights, CAP_GETPEERNAME),
-	    &fp, NULL, NULL);
+	    &fp, NULL, NULL, DTYPE_SOCKET);
 	if (error != 0)
 		return (error);
 	so = fp->f_data;
Index: sys/kern/uipc_usrreq.c
===================================================================
--- sys/kern/uipc_usrreq.c	(revision 312784)
+++ sys/kern/uipc_usrreq.c	(working copy)
@@ -270,7 +270,7 @@ static struct mtx	unp_defers_lock;
 #define	UNP_PCB_LOCK_ASSERT(unp)	mtx_assert(&(unp)->unp_mtx, MA_OWNED)
 
 static int	uipc_connect2(struct socket *, struct socket *);
-static int	uipc_ctloutput(struct socket *, struct sockopt *);
+static int	uipc_ctloutput(void *, struct sockopt *);
 static int	unp_connect(struct socket *, struct sockaddr *,
 		    struct thread *);
 static int	unp_connectat(int, struct socket *, struct sockaddr *,
@@ -284,6 +284,7 @@ static void	unp_drop(struct unpcb *);
 static void	unp_gc(__unused void *, int);
 static void	unp_scan(struct mbuf *, void (*)(struct filedescent **, int));
 static void	unp_discard(struct file *);
+static void	unp_free(struct unpcb *);
 static void	unp_freerights(struct filedescent **, int);
 static void	unp_init(void);
 static int	unp_internalize(struct mbuf **, struct thread *);
@@ -430,7 +431,7 @@ uipc_attach(struct socket *so, int proto, struct t
 	unp->unp_socket = so;
 	so->so_pcb = unp;
 	unp->unp_refcount = 1;
-	if (so->so_head != NULL)
+	if (so->so_listen != NULL)
 		unp->unp_flags |= UNP_NASCENT;
 
 	UNP_LIST_LOCK();
@@ -552,7 +553,7 @@ restart:
 
 	UNP_LINK_WLOCK();
 	UNP_PCB_LOCK(unp);
-	VOP_UNP_BIND(vp, unp->unp_socket);
+	VOP_UNP_BIND(vp, unp);
 	unp->unp_vnode = vp;
 	unp->unp_addr = soun;
 	unp->unp_flags &= ~UNP_BINDING;
@@ -646,14 +647,35 @@ uipc_connect2(struct socket *so1, struct socket *s
 static void
 uipc_detach(struct socket *so)
 {
-	struct unpcb *unp, *unp2;
+	struct unpcb *unp;
+
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("%s: unp == NULL", __func__));
+
+	unp_free(unp);
+}
+
+static void
+uipc_listenclose(struct solisten *sol)
+{
+	struct unpcb *unp;
+
+	unp = soltounpcb(sol);
+	KASSERT(unp != NULL, ("%s: unp == NULL", __func__));
+	KASSERT(unp->unp_conn == NULL && unp->unp_flags & UNP_LISTENING,
+	    ("%s: bad unp %p", __func__, unp));
+
+	unp_free(unp);
+}
+
+static void
+unp_free(struct unpcb *unp)
+{
+	struct unpcb *unp2;
 	struct sockaddr_un *saved_unp_addr;
 	struct vnode *vp;
 	int freeunp, local_unp_rights;
 
-	unp = sotounpcb(so);
-	KASSERT(unp != NULL, ("uipc_detach: unp == NULL"));
-
 	vp = NULL;
 	local_unp_rights = 0;
 
@@ -698,7 +720,10 @@ uipc_detach(struct socket *so)
 	local_unp_rights = unp_rights;
 	UNP_LINK_WUNLOCK();
 teardown:
-	unp->unp_socket->so_pcb = NULL;
+	if (unp->unp_flags & UNP_LISTENING)
+		unp->unp_listen->sol_pcb = NULL;
+	else
+		unp->unp_socket->so_pcb = NULL;
 	saved_unp_addr = unp->unp_addr;
 	unp->unp_addr = NULL;
 	unp->unp_refcount--;
@@ -738,11 +763,15 @@ uipc_disconnect(struct socket *so)
 }
 
 static int
-uipc_listen(struct socket *so, int backlog, struct thread *td)
+uipc_listen(struct socket *so, struct solisten *sol, int backlog,
+    struct thread *td)
 {
 	struct unpcb *unp;
 	int error;
 
+	if (so == NULL)
+		return (0);
+
 	if (so->so_type != SOCK_STREAM && so->so_type != SOCK_SEQPACKET)
 		return (EOPNOTSUPP);
 
@@ -757,16 +786,12 @@ static int
 		return (error);
 	}
 
-	SOCK_LOCK(so);
-	error = solisten_proto_check(so);
-	if (error == 0) {
-		cru2x(td->td_ucred, &unp->unp_peercred);
-		unp->unp_flags |= UNP_HAVEPCCACHED;
-		solisten_proto(so, backlog);
-	}
-	SOCK_UNLOCK(so);
+	cru2x(td->td_ucred, &unp->unp_peercred);
+	unp->unp_flags |= UNP_LISTENING;
+	unp->unp_listen = sol;
+	VOP_UNP_BIND(unp->unp_vnode, unp);
 	UNP_PCB_UNLOCK(unp);
-	return (error);
+	return (0);
 }
 
 static int
@@ -1157,6 +1182,7 @@ static struct pr_usrreqs uipc_usrreqs_dgram = {
 	.pru_detach =		uipc_detach,
 	.pru_disconnect =	uipc_disconnect,
 	.pru_listen =		uipc_listen,
+	.pru_listenclose =	uipc_listenclose,
 	.pru_peeraddr =		uipc_peeraddr,
 	.pru_rcvd =		uipc_rcvd,
 	.pru_send =		uipc_send,
@@ -1179,6 +1205,7 @@ static struct pr_usrreqs uipc_usrreqs_seqpacket =
 	.pru_detach =		uipc_detach,
 	.pru_disconnect =	uipc_disconnect,
 	.pru_listen =		uipc_listen,
+	.pru_listenclose =	uipc_listenclose,
 	.pru_peeraddr =		uipc_peeraddr,
 	.pru_rcvd =		uipc_rcvd,
 	.pru_send =		uipc_send,
@@ -1201,6 +1228,7 @@ static struct pr_usrreqs uipc_usrreqs_stream = {
 	.pru_detach =		uipc_detach,
 	.pru_disconnect =	uipc_disconnect,
 	.pru_listen =		uipc_listen,
+	.pru_listenclose =	uipc_listenclose,
 	.pru_peeraddr =		uipc_peeraddr,
 	.pru_rcvd =		uipc_rcvd,
 	.pru_send =		uipc_send,
@@ -1213,17 +1241,20 @@ static struct pr_usrreqs uipc_usrreqs_stream = {
 };
 
 static int
-uipc_ctloutput(struct socket *so, struct sockopt *sopt)
+uipc_ctloutput(void *xpcb, struct sockopt *sopt)
 {
-	struct unpcb *unp;
+	struct unpcb *unp = (struct unpcb *)xpcb;
 	struct xucred xu;
 	int error, optval;
+	short type;
 
 	if (sopt->sopt_level != 0)
 		return (EINVAL);
 
-	unp = sotounpcb(so);
-	KASSERT(unp != NULL, ("uipc_ctloutput: unp == NULL"));
+	if (unp->unp_flags & UNP_LISTENING)
+		type = unp->unp_listen->sol_type;
+	else
+		type = unp->unp_socket->so_type;
 	error = 0;
 	switch (sopt->sopt_dir) {
 	case SOPT_GET:
@@ -1233,7 +1264,7 @@ static int
 			if (unp->unp_flags & UNP_HAVEPC)
 				xu = unp->unp_peercred;
 			else {
-				if (so->so_type == SOCK_STREAM)
+				if (type == SOCK_STREAM)
 					error = ENOTCONN;
 				else
 					error = EINVAL;
@@ -1319,7 +1350,7 @@ unp_connectat(int fd, struct socket *so, struct so
 {
 	struct sockaddr_un *soun = (struct sockaddr_un *)nam;
 	struct vnode *vp;
-	struct socket *so2, *so3;
+	struct socket *so2;
 	struct unpcb *unp, *unp2, *unp3;
 	struct nameidata nd;
 	char buf[SOCK_MAXADDRLEN];
@@ -1386,31 +1417,32 @@ unp_connectat(int fd, struct socket *so, struct so
 	 * and to protect simultaneous locking of multiple pcbs.
 	 */
 	UNP_LINK_WLOCK();
-	VOP_UNP_CONNECT(vp, &so2);
-	if (so2 == NULL) {
+	VOP_UNP_CONNECT(vp, &unp2);
+	if (unp2 == NULL) {
 		error = ECONNREFUSED;
 		goto bad2;
 	}
-	if (so->so_type != so2->so_type) {
-		error = EPROTOTYPE;
-		goto bad2;
-	}
+	UNP_PCB_LOCK(unp);
+	UNP_PCB_LOCK(unp2);
 	if (so->so_proto->pr_flags & PR_CONNREQUIRED) {
-		if (so2->so_options & SO_ACCEPTCONN) {
-			CURVNET_SET(so2->so_vnet);
-			so3 = sonewconn(so2, 0);
+		if (unp2->unp_flags & UNP_LISTENING) {
+			struct solisten *sol;
+
+			sol = unp2->unp_listen;
+			if (so->so_type != sol->sol_type) {
+				error = EPROTOTYPE;
+				goto bad3;
+			}
+			CURVNET_SET(sol->sol_vnet);
+			so2 = sonewconn(sol, 0);
 			CURVNET_RESTORE();
 		} else
-			so3 = NULL;
-		if (so3 == NULL) {
+			so2 = NULL;
+		if (so2 == NULL) {
 			error = ECONNREFUSED;
-			goto bad2;
+			goto bad3;
 		}
-		unp = sotounpcb(so);
-		unp2 = sotounpcb(so2);
-		unp3 = sotounpcb(so3);
-		UNP_PCB_LOCK(unp);
-		UNP_PCB_LOCK(unp2);
+		unp3 = sotounpcb(so2);
 		UNP_PCB_LOCK(unp3);
 		if (unp2->unp_addr != NULL) {
 			bcopy(unp2->unp_addr, sa, unp2->unp_addr->sun_len);
@@ -1431,30 +1463,34 @@ unp_connectat(int fd, struct socket *so, struct so
 		 * listen(); uipc_listen() cached that process's credentials
 		 * at that time so we can use them now.
 		 */
-		KASSERT(unp2->unp_flags & UNP_HAVEPCCACHED,
-		    ("unp_connect: listener without cached peercred"));
 		memcpy(&unp->unp_peercred, &unp2->unp_peercred,
 		    sizeof(unp->unp_peercred));
 		unp->unp_flags |= UNP_HAVEPC;
 		if (unp2->unp_flags & UNP_WANTCRED)
 			unp3->unp_flags |= UNP_WANTCRED;
-		UNP_PCB_UNLOCK(unp3);
 		UNP_PCB_UNLOCK(unp2);
-		UNP_PCB_UNLOCK(unp);
+		unp2 = unp3;
 #ifdef MAC
-		mac_socketpeer_set_from_socket(so, so3);
-		mac_socketpeer_set_from_socket(so3, so);
+		mac_socketpeer_set_from_socket(so, so2);
+		mac_socketpeer_set_from_socket(so2, so);
 #endif
+	} else {	/* !UNP_LISTENING */
+		so2 = unp2->unp_socket;
+		if (so2->so_type != so->so_type) {
+			error = EPROTOTYPE;
+			goto bad3;
+		}
+		if (so2->so_proto->pr_flags & PR_CONNREQUIRED) {
+			error = ECONNREFUSED;
+			goto bad3;
+		}
+	}
 
-		so2 = so3;
-	}
-	unp = sotounpcb(so);
-	KASSERT(unp != NULL, ("unp_connect: unp == NULL"));
-	unp2 = sotounpcb(so2);
-	KASSERT(unp2 != NULL, ("unp_connect: unp2 == NULL"));
-	UNP_PCB_LOCK(unp);
-	UNP_PCB_LOCK(unp2);
+	KASSERT(unp2 != NULL && so2 != NULL && unp2->unp_socket == so2 &&
+	    sotounpcb(so2) == unp2,
+	    ("%s: unp2 %p so2 %p", __func__, unp2, so2));
 	error = unp_connect2(so, so2, PRU_CONNECT);
+bad3:
 	UNP_PCB_UNLOCK(unp2);
 	UNP_PCB_UNLOCK(unp);
 bad2:
@@ -1618,8 +1654,13 @@ unp_pcblist(SYSCTL_HANDLER_ARGS)
 	     unp = LIST_NEXT(unp, unp_link)) {
 		UNP_PCB_LOCK(unp);
 		if (unp->unp_gencnt <= gencnt) {
-			if (cr_cansee(req->td->td_ucred,
-			    unp->unp_socket->so_cred)) {
+			struct ucred *cr;
+
+			if (unp->unp_flags & UNP_LISTENING)
+				cr = unp->unp_listen->sol_cred;
+			else
+				cr = unp->unp_socket->so_cred;
+			if (cr_cansee(req->td->td_ucred, cr)) {
 				UNP_PCB_UNLOCK(unp);
 				continue;
 			}
@@ -1653,7 +1694,10 @@ unp_pcblist(SYSCTL_HANDLER_ARGS)
 				      &xu->xu_caddr,
 				      unp->unp_conn->unp_addr->sun_len);
 			bcopy(unp, &xu->xu_unp, sizeof *unp);
-			sotoxsocket(unp->unp_socket, &xu->xu_socket);
+			if (unp->unp_flags & UNP_LISTENING)
+				soltoxsocket(unp->unp_listen, &xu->xu_socket);
+			else
+				sotoxsocket(unp->unp_socket, &xu->xu_socket);
 			UNP_PCB_UNLOCK(unp);
 			error = SYSCTL_OUT(req, xu, sizeof *xu);
 		} else {
@@ -2237,8 +2281,8 @@ unp_accessable(struct filedescent **fdep, int fdco
 static void
 unp_gc_process(struct unpcb *unp)
 {
-	struct socket *soa;
 	struct socket *so;
+	struct solisten *sol;
 	struct file *fp;
 
 	/* Already processed. */
@@ -2258,28 +2302,31 @@ unp_gc_process(struct unpcb *unp)
 		return;
 	}
 
-	/*
-	 * Mark all sockets we reference with RIGHTS.
-	 */
-	so = unp->unp_socket;
-	if ((unp->unp_gcflag & UNPGC_IGNORE_RIGHTS) == 0) {
-		SOCKBUF_LOCK(&so->so_rcv);
-		unp_scan(so->so_rcv.sb_mb, unp_accessable);
-		SOCKBUF_UNLOCK(&so->so_rcv);
+	if ((unp->unp_flags & UNP_LISTENING) == 0) {
+		/*
+		 * Mark all sockets we reference with RIGHTS.
+		 */
+		so = unp->unp_socket;
+		if ((unp->unp_gcflag & UNPGC_IGNORE_RIGHTS) == 0) {
+			SOCKBUF_LOCK(&so->so_rcv);
+			unp_scan(so->so_rcv.sb_mb, unp_accessable);
+			SOCKBUF_UNLOCK(&so->so_rcv);
+		}
+	} else {
+		/*
+		 * Mark all sockets in our accept queue.
+		 */
+		sol = unp->unp_listen;
+		SOLISTEN_LOCK(sol);
+		TAILQ_FOREACH(so, &sol->sol_comp, so_list) {
+			if (sotounpcb(so)->unp_gcflag & UNPGC_IGNORE_RIGHTS)
+				continue;
+			SOCKBUF_LOCK(&so->so_rcv);
+			unp_scan(so->so_rcv.sb_mb, unp_accessable);
+			SOCKBUF_UNLOCK(&so->so_rcv);
+		}
+		SOLISTEN_UNLOCK(sol);
 	}
-
-	/*
-	 * Mark all sockets in our accept queue.
-	 */
-	ACCEPT_LOCK();
-	TAILQ_FOREACH(soa, &so->so_comp, so_list) {
-		if ((sotounpcb(soa)->unp_gcflag & UNPGC_IGNORE_RIGHTS) != 0)
-			continue;
-		SOCKBUF_LOCK(&soa->so_rcv);
-		unp_scan(soa->so_rcv.sb_mb, unp_accessable);
-		SOCKBUF_UNLOCK(&soa->so_rcv);
-	}
-	ACCEPT_UNLOCK();
 	unp->unp_gcflag |= UNPGC_SCANNED;
 }
 
@@ -2454,7 +2501,6 @@ unp_scan(struct mbuf *m0, void (*op)(struct filede
 void
 vfs_unp_reclaim(struct vnode *vp)
 {
-	struct socket *so;
 	struct unpcb *unp;
 	int active;
 
@@ -2464,10 +2510,7 @@ vfs_unp_reclaim(struct vnode *vp)
 
 	active = 0;
 	UNP_LINK_WLOCK();
-	VOP_UNP_CONNECT(vp, &so);
-	if (so == NULL)
-		goto done;
-	unp = sotounpcb(so);
+	VOP_UNP_CONNECT(vp, &unp);
 	if (unp == NULL)
 		goto done;
 	UNP_PCB_LOCK(unp);
@@ -2503,8 +2546,8 @@ db_print_unpflags(int unp_flags)
 		db_printf("%sUNP_HAVEPC", comma ? ", " : "");
 		comma = 1;
 	}
-	if (unp_flags & UNP_HAVEPCCACHED) {
-		db_printf("%sUNP_HAVEPCCACHED", comma ? ", " : "");
+	if (unp_flags & UNP_LISTENING) {
+		db_printf("%sUNP_LISTENING", comma ? ", " : "");
 		comma = 1;
 	}
 	if (unp_flags & UNP_WANTCRED) {
Index: sys/kern/vfs_default.c
===================================================================
--- sys/kern/vfs_default.c	(revision 312784)
+++ sys/kern/vfs_default.c	(working copy)
@@ -1124,7 +1124,7 @@ int
 vop_stdunp_bind(struct vop_unp_bind_args *ap)
 {
 
-	ap->a_vp->v_socket = ap->a_socket;
+	ap->a_vp->v_unpcb = ap->a_unpcb;
 	return (0);
 }
 
@@ -1132,7 +1132,7 @@ int
 vop_stdunp_connect(struct vop_unp_connect_args *ap)
 {
 
-	*ap->a_socket = ap->a_vp->v_socket;
+	*ap->a_unpcb = ap->a_vp->v_unpcb;
 	return (0);
 }
 
@@ -1140,7 +1140,7 @@ int
 vop_stdunp_detach(struct vop_unp_detach_args *ap)
 {
 
-	ap->a_vp->v_socket = NULL;
+	ap->a_vp->v_unpcb = NULL;
 	return (0);
 }
 
Index: sys/kern/vfs_subr.c
===================================================================
--- sys/kern/vfs_subr.c	(revision 312784)
+++ sys/kern/vfs_subr.c	(working copy)
@@ -2992,7 +2992,10 @@ _vdrop(struct vnode *vp, bool locked)
 	/* XXX Elsewhere we detect an already freed vnode via NULL v_op. */
 	vp->v_op = NULL;
 #endif
-	bzero(&vp->v_un, sizeof(vp->v_un));
+	vp->v_mountedhere = NULL;
+	vp->v_unpcb = NULL;
+	vp->v_rdev = NULL;
+	vp->v_fifoinfo = NULL;
 	vp->v_lasta = vp->v_clen = vp->v_cstart = vp->v_lastw = 0;
 	vp->v_iflag = 0;
 	vp->v_vflag = 0;
Index: sys/kern/vnode_if.src
===================================================================
--- sys/kern/vnode_if.src	(revision 312784)
+++ sys/kern/vnode_if.src	(working copy)
@@ -662,7 +662,7 @@ vop_advise {
 
 vop_unp_bind {
 	IN struct vnode *vp;
-	IN struct socket *socket;
+	IN struct unpcb *unpcb;
 };
 
 
@@ -670,7 +670,7 @@ vop_unp_bind {
 
 vop_unp_connect {
 	IN struct vnode *vp;
-	OUT struct socket **socket;
+	OUT struct unpcb **unpcb;
 };
 
 
Index: sys/netinet/in_pcb.h
===================================================================
--- sys/netinet/in_pcb.h	(revision 312784)
+++ sys/netinet/in_pcb.h	(working copy)
@@ -192,7 +192,10 @@ struct inpcb {
 	struct	inpcbinfo *inp_pcbinfo;	/* (c) PCB list info */
 	struct	inpcbgroup *inp_pcbgroup; /* (g/i) PCB group list */
 	LIST_ENTRY(inpcb) inp_pcbgroup_wild; /* (g/i/h) group wildcard entry */
-	struct	socket *inp_socket;	/* (i) back pointer to socket */
+	union {
+		struct socket *inp_socket;	/* (i) back pointer to socket */
+		struct solisten *inp_solisten;	/* or solisten */
+	};
 	struct	ucred	*inp_cred;	/* (c) cache of socket cred */
 	u_int32_t inp_flow;		/* (i) IPv6 flow information */
 	int	inp_flags;		/* (i) generic IP/datagram flags */
@@ -618,6 +621,7 @@ short	inp_so_options(const struct inpcb *inp);
 #define	INP_RECVFLOWID		0x00000100 /* populate recv datagram with flow info */
 #define	INP_RECVRSSBUCKETID	0x00000200 /* populate recv datagram with bucket id */
 #define	INP_RATE_LIMIT_CHANGED	0x00000400 /* rate limit needs attention */
+#define	INP_LISTENING		0x00000800 /* this is a listening socket */
 
 /*
  * Flags passed to in_pcblookup*() functions.
@@ -631,6 +635,7 @@ short	inp_so_options(const struct inpcb *inp);
 
 #define	sotoinpcb(so)	((struct inpcb *)(so)->so_pcb)
 #define	sotoin6pcb(so)	sotoinpcb(so) /* for KAME src sync over BSD*'s */
+#define	soltoinpcb(sol)	((struct inpcb *)(sol)->sol_pcb)
 
 #define	INP_SOCKAF(so) so->so_proto->pr_domain->dom_family
 
Index: sys/netinet/ip_output.c
===================================================================
--- sys/netinet/ip_output.c	(revision 312784)
+++ sys/netinet/ip_output.c	(working copy)
@@ -965,9 +965,10 @@ in_delayed_cksum(struct mbuf *m)
  * IP socket option processing.
  */
 int
-ip_ctloutput(struct socket *so, struct sockopt *sopt)
+ip_ctloutput(void *xpcb, struct sockopt *sopt)
 {
-	struct	inpcb *inp = sotoinpcb(so);
+	struct inpcb *inp = (struct inpcb *)xpcb;
+	struct socket *so = inp->inp_socket;
 	int	error, optval;
 #ifdef	RSS
 	uint32_t rss_bucket;
Index: sys/netinet/ip_var.h
===================================================================
--- sys/netinet/ip_var.h	(revision 312784)
+++ sys/netinet/ip_var.h	(working copy)
@@ -203,7 +203,7 @@ void	inp_freemoptions(struct ip_moptions *);
 int	inp_getmoptions(struct inpcb *, struct sockopt *);
 int	inp_setmoptions(struct inpcb *, struct sockopt *);
 
-int	ip_ctloutput(struct socket *, struct sockopt *sopt);
+int	ip_ctloutput(void *, struct sockopt *sopt);
 void	ip_drain(void);
 int	ip_fragment(struct ip *ip, struct mbuf **m_frag, int mtu,
 	    u_long if_hwassist_flags);
@@ -223,7 +223,7 @@ void	ip_savecontrol(struct inpcb *, struct mbuf **
 	    struct mbuf *);
 void	ip_slowtimo(void);
 void	ip_fillid(struct ip *);
-int	rip_ctloutput(struct socket *, struct sockopt *);
+int	rip_ctloutput(void *, struct sockopt *);
 void	rip_ctlinput(int, struct sockaddr *, void *);
 void	rip_init(void);
 int	rip_input(struct mbuf **, int *, int);
Index: sys/netinet/raw_ip.c
===================================================================
--- sys/netinet/raw_ip.c	(revision 312784)
+++ sys/netinet/raw_ip.c	(working copy)
@@ -562,9 +562,10 @@ rip_output(struct mbuf *m, struct socket *so, ...)
  * XXX-BZ inp locking?
  */
 int
-rip_ctloutput(struct socket *so, struct sockopt *sopt)
+rip_ctloutput(void *xpcb, struct sockopt *sopt)
 {
-	struct	inpcb *inp = sotoinpcb(so);
+	struct inpcb *inp = (struct inpcb *)xpcb;
+	struct socket *so = inp->inp_socket;
 	int	error, optval;
 
 	if (sopt->sopt_level != IPPROTO_IP) {
@@ -626,7 +627,7 @@ int
 			break;
 
 		default:
-			error = ip_ctloutput(so, sopt);
+			error = ip_ctloutput(inp, sopt);
 			break;
 		}
 		break;
Index: sys/netinet/sctp_input.c
===================================================================
--- sys/netinet/sctp_input.c	(revision 312784)
+++ sys/netinet/sctp_input.c	(working copy)
@@ -161,13 +161,13 @@ sctp_handle_init(struct mbuf *m, int iphlen, int o
 			*abort_no_unlock = 1;
 		goto outnow;
 	}
-	/* We are only accepting if we have a socket with positive
-	 * so_qlimit. */
+	/*
+	 * Check if the socket is accepting.
+	 */
 	if ((stcb == NULL) &&
 	    ((inp->sctp_flags & SCTP_PCB_FLAGS_SOCKET_GONE) ||
 	    (inp->sctp_flags & SCTP_PCB_FLAGS_SOCKET_ALLGONE) ||
-	    (inp->sctp_socket == NULL) ||
-	    (inp->sctp_socket->so_qlimit == 0))) {
+	    !(inp->sctp_flags & SCTP_PCB_FLAGS_ACCEPTING))) {
 		/*
 		 * FIX ME ?? What about TCP model and we have a
 		 * match/restart case? Actually no fix is needed. the lookup
@@ -1605,7 +1605,7 @@ sctp_process_cookie_existing(struct mbuf *m, int i
 			sctp_stop_all_cookie_timers(stcb);
 			if (((stcb->sctp_ep->sctp_flags & SCTP_PCB_FLAGS_TCPTYPE) ||
 			    (stcb->sctp_ep->sctp_flags & SCTP_PCB_FLAGS_IN_TCPPOOL)) &&
-			    (inp->sctp_socket->so_qlimit == 0)
+			    !(stcb->sctp_ep->sctp_flags & SCTP_PCB_FLAGS_ACCEPTING)
 			    ) {
 #if defined(__APPLE__) || defined(SCTP_SO_LOCK_TESTING)
 				struct socket *so;
@@ -1806,7 +1806,7 @@ sctp_process_cookie_existing(struct mbuf *m, int i
 
 			if (((stcb->sctp_ep->sctp_flags & SCTP_PCB_FLAGS_TCPTYPE) ||
 			    (stcb->sctp_ep->sctp_flags & SCTP_PCB_FLAGS_IN_TCPPOOL)) &&
-			    (inp->sctp_socket->so_qlimit == 0)) {
+			    !(stcb->sctp_ep->sctp_flags & SCTP_PCB_FLAGS_ACCEPTING)) {
 #if defined(__APPLE__) || defined(SCTP_SO_LOCK_TESTING)
 				struct socket *so;
 #endif
@@ -2317,7 +2317,7 @@ sctp_process_cookie_new(struct mbuf *m, int iphlen
 	*notification = SCTP_NOTIFY_ASSOC_UP;
 	if (((stcb->sctp_ep->sctp_flags & SCTP_PCB_FLAGS_TCPTYPE) ||
 	    (stcb->sctp_ep->sctp_flags & SCTP_PCB_FLAGS_IN_TCPPOOL)) &&
-	    (inp->sctp_socket->so_qlimit == 0)) {
+	    !(stcb->sctp_ep->sctp_flags & SCTP_PCB_FLAGS_ACCEPTING)) {
 		/*
 		 * This is an endpoint that called connect() how it got a
 		 * cookie that is NEW is a bit of a mystery. It must be that
@@ -2343,7 +2343,7 @@ sctp_process_cookie_new(struct mbuf *m, int iphlen
 		SCTP_SOCKET_UNLOCK(so, 1);
 #endif
 	} else if ((stcb->sctp_ep->sctp_flags & SCTP_PCB_FLAGS_TCPTYPE) &&
-	    (inp->sctp_socket->so_qlimit)) {
+	    (stcb->sctp_ep->sctp_flags & SCTP_PCB_FLAGS_ACCEPTING)) {
 		/*
 		 * We don't want to do anything with this one. Since it is
 		 * the listening guy. The timer will get started for
@@ -2720,13 +2720,14 @@ sctp_handle_cookie_echo(struct mbuf *m, int iphlen
 	sctp_start_net_timers(*stcb);
 	if ((*inp_p)->sctp_flags & SCTP_PCB_FLAGS_TCPTYPE) {
 		if (!had_a_existing_tcb ||
-		    (((*inp_p)->sctp_flags & SCTP_PCB_FLAGS_CONNECTED) == 0)) {
+		    ((*inp_p)->sctp_flags & SCTP_PCB_FLAGS_ACCEPTING)) {
 			/*
 			 * If we have a NEW cookie or the connect never
 			 * reached the connected state during collision we
 			 * must do the TCP accept thing.
 			 */
-			struct socket *so, *oso;
+			struct solisten *sol;
+			struct socket *so;
 			struct sctp_inpcb *inp;
 
 			if (notification == SCTP_NOTIFY_ASSOC_RESTART) {
@@ -2741,12 +2742,11 @@ sctp_handle_cookie_echo(struct mbuf *m, int iphlen
 				}
 				return (m);
 			}
-			oso = (*inp_p)->sctp_socket;
+			sol = (*inp_p)->sctp_solisten;
 			atomic_add_int(&(*stcb)->asoc.refcnt, 1);
 			SCTP_TCB_UNLOCK((*stcb));
 			CURVNET_SET(oso->so_vnet);
-			so = sonewconn(oso, 0
-			    );
+			so = sonewconn(sol, 0);
 			CURVNET_RESTORE();
 			SCTP_TCB_LOCK((*stcb));
 			atomic_subtract_int(&(*stcb)->asoc.refcnt, 1);
Index: sys/netinet/sctp_pcb.h
===================================================================
--- sys/netinet/sctp_pcb.h	(revision 312784)
+++ sys/netinet/sctp_pcb.h	(working copy)
@@ -385,8 +385,11 @@ struct sctp_inpcb {
 	 */
 	struct sctp_laddr *next_addr_touse;
 
-	/* back pointer to our socket */
-	struct socket *sctp_socket;
+	/* back pointer to our socket / listening socket */
+	union {
+		struct socket *sctp_socket;
+		struct solisten *sctp_solisten;
+	};
 	uint64_t sctp_features;	/* Feature flags */
 	uint32_t sctp_flags;	/* INP state flag set */
 	uint32_t sctp_mobility_features;	/* Mobility  Feature flags */
